
#ifndef intersct_h
#define intersct_h

#include "bzmapper.h"


typedef const vec3 cvec3;


extern int point_to_square (cvec3 pos1,
                            cvec3 pos2, cvec3 size2, const double rot2);

extern int square_to_square (cvec3 pos1, cvec3 size1, const double rot1,
                             cvec3 pos2, cvec3 size2, const double rot2);

extern int square_in_square (cvec3 inpos, cvec3 insize, const double inrot,
                             cvec3 outpos, cvec3 outsize,
                             const double outrot);

extern void center_square (cvec3 cpos, const double crot,   /* center */
                           cvec3 tpos, const double trot,   /* target */
                           vec3 rpos, double *rrot);        /* result */

extern int box_to_box (cvec3 pos1, cvec3 size1, const double rot1,
                       cvec3 pos2, cvec3 size2, const double rot2);

extern int box_to_pyr (cvec3 pos1, cvec3 size1, const double rot1,
                       cvec3 pos2, cvec3 size2, const double rot2);

extern int box_to_tetra (cvec3 pos1, cvec3 size1, const double rot1,
                         cvec3 *vertices);

extern int pyr_to_pyr (cvec3 pos1, cvec3 size1, const double rot1,
                       cvec3 pos2, cvec3 size2, const double rot2);

extern int pyr_to_tetra (cvec3 pos1, cvec3 size1, const double rot1,
                         cvec3 *vertices);

extern int tetra_to_tetra (cvec3 *vertices1, cvec3 *vertices2);

extern int check_box_overlap (cvec3 pos1, cvec3 size1, const double rot1,
                              cvec3 pos2, cvec3 size2, const double rot2);

extern int check_pyr_overlap (cvec3 ppos, cvec3 psize, const double prot,
                              cvec3 bpos, cvec3 bsize, const double brot,
                              double *factor);


#endif                          /* intersct_h */
