
#ifndef keywords_h
#define keywords_h


extern int keyword_parse (const char *buf, int buflen, const char **pos);

extern const char *keyword_string (int key);
extern int keyword_ended (int key);
extern int keyword_top_level (int key);
extern int keyword_is_end (const char *buf);
extern int keyword_raw_input (int key);
extern int keyword_flow_control (int key);

enum keywords_enum {

  end_key,

  box_key,
  pyr_key,
  tetra_key,
  base_key,
  tele_key,
  link_key,
  zone_key,
  arc_key,
  text_key,
  image_key,
  paths_key,
  steps_key,
  weapon_key,
  world_key,

  group_key,
  defgroup_key,

  modify_key,
  delete_key,
  undelete_key,
  intersect_key,

  include_key,
  repeat_key,
  while_key,
  if_key,
  else_key,
  var_key,
  const_key,

  print_key,
  seed_key,
  flipzstyle_key,               /* remove ? */
  loadfont_key,
  quit_key,

  name_key,
  position_key,
  size_key,
  rotation_key,
  drivethrough_key,
  shootthrough_key,
  passable_key,
  flipz_key,

  weapon_type_key,
  weapon_delay_key,
  weapon_init_delay_key,

  flag_key,
  team_key,
  safety_key,

  color_key,
  vcolor_key,
  to_key,
  from_key,
  border_key,
  flag_height_key,

  vertex_key,
  visible_key,
  tilt_key,
  segments_key,
  hole_key,
  tophole_key,
  point_key,
  angle_key,
  closedloop_key,
  convert_key,
  options_key,

  short_pyr_key,                /* shorthand keywords */
  short_tele_key,
  short_pos_key,
  short_rot_key,
  short_var_key,
  short_const_key,
  short_drivethrough_key,
  short_shootthrough_key,

  keywords_count
};


#endif                          /* keywords_h */
