
#ifndef linebuf_h
#define linebuf_h


#define LINEBUF_OK      (0)
#define LINEBUF_EOF     (-2)
#define LINEBUF_ERROR   (-1)

#define LINEBUF_INC_DEPTH	(32)


extern void init_line_buffer (void);
extern void free_line_buffer (void);

extern int include_file (const char *filename);

extern int get_line (char *buf, int buflen);
extern int buffer_on (void);
extern int buffer_off (void);
extern int buffer_jump (int line);
extern int unbuffer_line (void);


/*
 * For debugging and error messages
 */

typedef const struct _filedef *linebuf_fd;

extern int current_line_number (void);
extern linebuf_fd current_file (void);
extern const char *current_filename (void);
extern const char *top_filename (linebuf_fd fd);
extern void print_file_stack (linebuf_fd fd);

extern void push_debug_info (int linenum, linebuf_fd fd);
extern void pop_debug_info (void);


#endif                          /* linebuf_h */
