
#ifndef list_h
#define list_h


#define LIST_CHUNK_DEFAULT		(64)

typedef struct {
  int count;
  int chunk;
  void **items;
} List;

#define LIST(x) List x = {0, LIST_CHUNK_DEFAULT, NULL}


extern void list_init (List * l);
extern int list_add (void *item, List * l);
extern int list_rem (void *item, List * l);
extern int list_rem_num (int item_num, List * l);
extern int list_find (void *item, List * l);
extern void list_free (List * l);
extern void list_nuke (void (*free_func) (void *), List * l);

/*
 * Remove the last item from the list, and return the pointer.
 */
extern void *list_pop (List * l);

/*
 * Start at item #0 and execute run_func() until it
 * returns < 0. If all items are run then -1 is returned,
 * otherwise the first item number to return < 0 is
 * returned.
 */
extern int list_run (int (*run_func) (void *), List * l);


#endif                          /* list_h */
