
#include <stdio.h>
#include "../hdrs/global.h"

int
main (int argc, char **argv)
{
  FILE *outfile;

  if (argc != 2) {
    printf ("Usage:  %s <outfile>\n", argv[0]);
    return -1;
  }

  outfile = fopen (argv[1], "w");
  if (outfile == NULL) {
    perror ("fopen");
    return -1;
  }

  fprintf (outfile, "\n");
  fprintf (outfile, "#ifndef globals_h\n");
  fprintf (outfile, "#define globals_h\n");
  fprintf (outfile, "\n");
  fprintf (outfile, "\n");

  fprintf (outfile, "#define WorldSize   (%10f)\n", WorldSize);
  fprintf (outfile, "\n");
  fprintf (outfile, "#define BoxBase     (%10f)\n", BoxBase);
  fprintf (outfile, "#define BoxHeight   (%10f)\n", BoxHeight);
  fprintf (outfile, "#define PyrBase     (%10f)\n", PyrBase);
  fprintf (outfile, "#define PyrHeight   (%10f)\n", PyrHeight);
  fprintf (outfile, "#define BaseSize    (%10f)\n", BaseSize);
  fprintf (outfile, "#define TeleWidth   (%10f)\n", TeleWidth);
  fprintf (outfile, "#define TeleBreadth (%10f)\n", TeleBreadth);
  fprintf (outfile, "#define TeleHeight  (%10f)\n", TeleHeight);

  fprintf (outfile, "\n");
  fprintf (outfile, "\n");
  fprintf (outfile, "#endif  /* globals_h */\n");
  fprintf (outfile, "\n");

  fclose (outfile);

  return 0;
}
